var CACHE = 'cache-and-update';

self.addEventListener('install', function (evt) {
   console.log('The service worker is being installed.');
   evt.waitUntil(precache());
});

self.addEventListener('fetch', function (evt: FetchEvent) {
   console.log('The service worker is serving the asset.');
   evt.respondWith(fromCache(evt.request, update(evt.request)));
   evt.waitUntil(update(evt.request));
});

function precache() {
   return caches.open(CACHE).then(function (cache) {
      return cache.addAll([
         "./",
         "./index.html"
      ]);
   });
}

function fromCache(request, update) {
   return caches.open(CACHE).then(function (cache) {
      return cache.match(request).then(function (matching) {
         return matching || update;
      });
   });
}

function update(request) {
   return caches.open(CACHE).then(function (cache) {
      return fetch(request).then(function (response) {
         return cache.put(request, response);
      });
   });
}